	program nuldrread

		implicit none
		integer :: i, j, m1, m2, m3, n1, n2, n3, mn1, mn2, mn3,&
                                 nr, nrmax
		integer, dimension(50000,3) :: it = 0
		integer, dimension(50000)  :: stattry = 0
		real, dimension(50000) :: philink

	open(unit = 5, file = 'streamer', status = 'old')
	open(unit = 7, file = 'newtree', status = 'replace')
	open(unit = 8, file = 'ldr', status = 'replace')
        	i = 1

	do
	read(5,*, end = 105) it(i,1), it(i,2), it(i,3), philink(i), stattry(i)
                i = i + 1
	end do

  105		nrmax = count(stattry .ne.0)
	print *, 'File reading completed.'
	print *, 'Number of links =  ', nrmax
	print *, 'Constructing list of breakdown links.'

		!   START
		!   The routine proceeds backward along the array "it".  From each site
		!   it searches to find a neighbor which is just one grid step away,
		!   and because this has an earlier "stattry" number, it is being
		!   connected to a point in the tree which grew earlier.

	do i = nrmax, 1, -1                !  Selection of site to be connected.

		if(i .eq. 1) exit          !  The connection to the needle must be
                                           !  supplied separately.

		n1 = it(i,1)
		n2 = it(i,2)
		n3 = it(i,3)

		do j = i-1, 1, -1          !  Search for neighbor.

			m1 = it(j,1)
			m2 = it(j,2)
			m3 = it(j,3)

			mn1 = iabs(m1-n1)
			mn2 = iabs(m2-n2)
			mn3 = iabs(m3-n3)
	if(((mn1 .eq. 1) .and. (mn2 .eq. 0) .and. (mn3 .eq. 0)) .or. &
           ((mn1 .eq. 0) .and. (mn2 .eq. 1) .and. (mn3 .eq. 0)) .or. &     
           ((mn1 .eq. 0) .and. (mn2 .eq. 0) .and. (mn3 .eq. 1))) then
		write(7, fmt = 107) it(j,1:3), it(i,1:3), philink(i), stattry(j)
 
   107	format(6i5,'    ',f6.4,' ',i9)
		exit
	else
		cycle
	end if

		end do

	end do

	close(5)
	close(7)
		i = nrmax
	do while(i .gt. 1)                 !  Selection of site to be connected.
		                           !  The connection to the needle must be
                                           !  supplied separately.

		n1 = it(i,1)
		n2 = it(i,2)
		n3 = it(i,3)

		do j = i-1, 1, -1          !  Search for neighbor.

			m1 = it(j,1)
			m2 = it(j,2)
			m3 = it(j,3)

			mn1 = iabs(m1-n1)
			mn2 = iabs(m2-n2)
			mn3 = iabs(m3-n3)
	if(((mn1 .eq. 1) .and. (mn2 .eq. 0) .and. (mn3 .eq. 0)) .or. &
           ((mn1 .eq. 0) .and. (mn2 .eq. 1) .and. (mn3 .eq. 0)) .or. &     
           ((mn1 .eq. 0) .and. (mn2 .eq. 0) .and. (mn3 .eq. 1))) then
		write(8, fmt = 107) it(j,1:3), it(i,1:3), philink(i), stattry(i)
 
		exit
	else
		cycle
	end if
		end do
		i = j
	end do
	close(8)
	end program nuldrread
