	module nbrdisp

	use dparlib

	use globals

	use breakup

	implicit none

	private
	public shownbrs

	contains


!!  JGH:  Note that this routine probably doesn't do what we want
!!  if the process array is not 1 x 1 x N
!!

        subroutine shownbrs (pblock, nbrs)
    
	  integer, dimension(1:2,1:3) :: pblock
          integer :: i, j, k, m
	  logical, dimension( 	pblock(1,1):pblock(2,1), &
	  			pblock(1,2):pblock(2,2), &
	  			pblock(1,3):pblock(2,3)) :: nbrs

          character( len = (1 + pblock(2,2) - pblock(1,2)) ) :: line




	  k = cglob / 2


    if ((pblock(1,3) .le. k) .and. (k .le. pblock(2,3))) then

           do i = pblock(1,1), pblock(2,1)
             do j = pblock(1,2), pblock(2,2)
                 m = 1+ j - pblock(1,2)
                 if(nbrs(i,j,k)) then 
                      line(m:m) = '+'
                 else if( .not. nbrs(i,j,k)) then
                      line(m:m) = '.'
                 end if
             end do

             print *, line 

           end do

    end if

        end subroutine shownbrs 

        end module nbrdisp 
