	module treedisp

	use dparlib

	use globals

	use breakup

	implicit none

	private
	public showtree

	contains

	!!
	!! JGH: this routine probably doesn't do what we want when the
	!! process array is not 1x1xN
	!!

        subroutine showtree(pblock, tree)
    
	  integer, dimension(1:2,1:3) :: pblock
          integer :: i, j, k, m
	  logical, dimension( 	pblock(1,1):pblock(2,1), &
				pblock(1,2):pblock(2,2), &
				pblock(1,3):pblock(2,3) ), intent(in) :: tree

          character( len = (1 + pblock(2,2)-pblock(1,2)) ) :: line

	! k = cglob/2


	! if ((pblock(1,3) .le. k) .and. (k .le. pblock(2,3)) ) then

	do k = pblock(1,3), pblock(2,3)

           do i =  pblock(1,1), pblock(2,1)
             do j =  pblock(1,2), pblock(2,2)
                    m = 1 + j - pblock(1,2)
             !    line(:) = ' '

                 if(tree(i,j,k)) then 
                      line(m:m) = '+'
                 else if( .not. tree(i,j,k)) then
                      line(m:m) = '.'
                 end if
             end do
             print *, line 
           end do

             print *, " "
	enddo ! k

	! endif

	return
        end subroutine showtree

        end module treedisp
